#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <string.h>
#include <fcntl.h>
#include <semaphore.h>
#include <pthread.h>


sem_t sem_sys;
sem_t sem_local;

struct params
{
	int start_index;
	int end_index;
};

int *elements;
int sum;

int no_of_elements;
int no_calculated = 0;

#define MAXLINE 256

void* start_thread(void *arg)
{
	struct params t = *((struct params*) arg);

	int fd[2];
	
	int ret_val;

	sem_wait(&sem_sys);
	ret_val = pipe(fd);
	sem_post(&sem_sys);

	if(ret_val < 0)
		cerr << "pipe error" << endl;
	
	pid_t pid;

	sem_wait(&sem_sys);
	pid = fork();
	sem_post(&sem_sys);

	if(pid < 0)
		cerr << "fork error" << endl;
	else if(pid > 0)
	{
		sem_wait(&sem_sys);
		close(fd[1]);
		sem_post(&sem_sys);

		char buf[MAXLINE];
		int p_sum;
		
		sem_wait(&sem_sys);
		read(fd[0], buf, 12);
		sem_post(&sem_sys);

		sem_wait(&sem_sys);
		memcpy(&p_sum, buf, sizeof(int));
		sem_post(&sem_sys);
		
		sem_wait(&sem_local);
		sum += p_sum;
		no_calculated += (t.end_index - t.start_index);
		sem_post(&sem_local);

	}
	else
	{
		close(fd[0]);

		int sum = 0;
		
		for(int i = t.start_index; i < t.end_index;i++)
			sum += elements[i];

		cout << "Partial sum: " << sum << endl;			
		char buf[MAXLINE];
		memcpy(buf, &sum, sizeof(int));
		write(fd[1], buf, MAXLINE);
		close(fd[1]);

		exit(0);
		
	}

	pthread_exit(0);
	return 0;
}

void main()
{
	sem_init(&sem_sys, 0, 0);
	sem_post(&sem_sys);

	sem_init(&sem_local, 0, 0);
	sem_post(&sem_local);
	
	cout << "Enter the no of elements: " << endl;
	cin >> no_of_elements;

	elements = new int[no_of_elements];
	
	cout << "Enter the elements: " << endl;

	for(int i =0; i < no_of_elements;i++)
		cin >> elements[i];

	int interval = 3;
	int current_index = 0;

	while(current_index < no_of_elements)
	{
		int end_index = ((current_index + interval) < no_of_elements) ? current_index + interval : no_of_elements;
		
		struct params *temp = new params;
		temp->start_index = current_index;
		temp->end_index = end_index;
		
		pthread_t new_thread;
		pthread_create(&new_thread, 0, &start_thread, temp);

		current_index = end_index;
	}
	
	for(;;)
	{
		sem_wait(&sem_local);
		if(no_calculated == no_of_elements)
		{
			cout << "\nTotal sum: " << sum << endl;
			delete[] elements;
			sem_post(&sem_local);
			break;
		}
		sem_post(&sem_local);
	}
}	
