#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <string.h>
#include <fcntl.h>
#include <semaphore.h>
#include <pthread.h>

#define DELIMITER	'd'

sem_t sem_sys;
sem_t sem_local;

struct params
{
	int row;
	int col;
};

int row_size1;
int col_size1;
int row_size2;
int col_size2;

int matrix1[10][10];
int matrix2[10][10];
int matrix3[10][10];

int no_of_elements = 0;

#define MAXLINE 256

void* start_thread(void *arg)
{
	struct params t = *((struct params*) arg);

	int fd[2];

	int ret_val;

	sem_wait(&sem_sys);
	ret_val = pipe(fd);
	sem_post(&sem_sys);

	if(ret_val < 0)
		cerr << "pipe error" << endl;

	pid_t pid;

	sem_wait(&sem_sys);
	pid = fork();
	sem_post(&sem_sys);

	if(pid < 0)
		cerr << "fork error" << endl;
	else if(pid > 0)
	{
		sem_wait(&sem_sys);
		close(fd[1]);
		sem_post(&sem_sys);

		char buf[MAXLINE];
		int this_element;

		sem_wait(&sem_sys);
		read(fd[0], buf, 12);
		sem_post(&sem_sys);

		sem_wait(&sem_sys);
		memcpy(&this_element, buf, sizeof(int));
		sem_post(&sem_sys);

		sem_wait(&sem_local);
		matrix3[t.row][t.col] = this_element;
          	no_of_elements++;
		sem_post(&sem_local);

	}
	else
	{
		close(fd[0]);

		int sum = 0;
		
		for(int i = 0; i < col_size1;i++)
			sum += matrix1[t.row][i] * matrix2[i][t.col];

		cout << "Partial product: " << sum << endl;		
		char buf[MAXLINE];
		memcpy(buf, &sum, sizeof(int));
		write(fd[1], buf, MAXLINE);
		close(fd[1]);

		exit(0);

	}

	pthread_exit(0);
	return 0;
}

void main()
{
	sem_init(&sem_sys, 0, 0);
	sem_post(&sem_sys);

	sem_init(&sem_local, 0, 0);
	sem_post(&sem_local);

        cout << "\nEnter the dimensions of matrix1" << endl;
	cout << "Rows: ";
	cin >> row_size1;
	cout << "\nCols: ";
	cin >> col_size1;

	cout << "\nEnter the dimensions of matrix2" << endl;
	cout << "Rows: ";
	cin >> row_size2;
	cout << "Cols: ";
	cin >> col_size2;

	if(col_size1 != row_size2)
	{
		cout << "Incompatible matrices" << endl;
		exit(1);
	}

	cout << "Enter the elements of matrix 1: " << endl;

	for(int i = 0;i < row_size1;i++)
		for(int j = 0;j < col_size1;j++)
			cin >> matrix1[i][j];

	cout << "Enter the elements of matrix 2: " << endl;

	for(int i = 0;i < row_size2;i++)
		for(int j =0;j < col_size2;j++)
			cin >> matrix2[i][j];

	int current_row = 0, current_col = 0;

	while(1)
	{
		pthread_t new_thread;
		struct params *t = new params;
		t->row = current_row;
		t->col = current_col;

		pthread_create(&new_thread, 0, &start_thread, t);
		sem_wait(&sem_local);

		if(current_col == col_size2 - 1)
		{
			current_col = 0;
			if(current_row + 1 == row_size1)
			{
				sem_post(&sem_local);
				break;
			}
			current_row++;
		}
		else
			current_col++;

		sem_post(&sem_local);

	}

       	for(;;)
	{
		sem_wait(&sem_sys);
		if(no_of_elements == row_size1 * col_size2)
		{
			cout << "Product of matrices: " << endl;
			for(int i = 0;i < row_size1;i++)
			{
				for(int j = 0;j < col_size2;j++)
					cout << matrix3[i][j] << " ";
				cout << endl;
			}

			cout << endl;

			sem_post(&sem_sys);
			break;
		}
		sem_post(&sem_sys);
	}

}
