/* TCP Server */

#include <stdio.h>
#include <iostream.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#define SERVER_TCP_PORT  3100
#define BUFLEN 		 256

void main(int argc, char** argv)
{
	int n;
	int bytes_to_read;
	int port;
	int sd, new_sd;
	socklen_t client_len;

	struct sockaddr_in server, client;
	char *bp;
	char buf[BUFLEN];

	port = SERVER_TCP_PORT;

	/* create a stream socket */

	if((sd = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	{
		cerr << "server: can't create a socket";
		exit(1);
	}

	/* Bind address to a socket */

	bzero((char*) &server, sizeof(struct sockaddr_in));
	server.sin_family = AF_INET;
	server.sin_port = htons(port);
	server.sin_addr.s_addr = htonl(INADDR_ANY);

	if(bind(sd, (struct sockaddr*) &server, sizeof(server)) == -1)
	{
		cerr << "can't bind name to socket";
		exit(1);
	}

	listen(sd, 5);

	while(1)
	{
		client_len = sizeof(client);
		if((new_sd = accept(sd, (struct sockaddr*) &client, &client_len)) == -1)
		{
			cerr << "server: can't accept client\n";
			exit(1);
		}
	
		bp = buf;
		bytes_to_read = BUFLEN;
	
		while((n = read(new_sd, bp, bytes_to_read)) > 0)
		{
			bp += n;
			bytes_to_read -= n;
		}
		
		write(new_sd, buf, BUFLEN);
		close(new_sd);
	}

	close(sd);
}
