/* TCP client */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <iostream.h>
#include <netdb.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#define SERVER_TCP_PORT 3000
#define BUFLEN		256

const int interval = 3;

int main(int argc, char** argv)
{
	int n;
	int bytes_to_read;
	int sd;
	int port = SERVER_TCP_PORT;
	int i;

	struct hostent *hp;
	struct sockaddr_in server;
	char *host = "127.0.0.1";
	char *bp, rbuf[BUFLEN], sbuf[BUFLEN];

	/*Create a stream socket*/

	if ((sd = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	{
		cerr << "client: can't create a socket\n";
		exit(1);
	}

	bzero((char*)&server, sizeof(struct sockaddr_in));
	server.sin_family = AF_INET;
	server.sin_port = htons(port);

	if((hp = gethostbyname(host)) == NULL)
	{
		cerr << "client: can't get server's address\n";
		exit(1);
	}
	
	bcopy(hp->h_addr, (char*) &server.sin_addr, hp->h_length);

	/* connecting to the server */

	if(connect(sd, (struct sockaddr*) &server, sizeof(server)) == -1)
	{
		cerr << "client: can't connect";
		exit(1);
	}

	cout << "Connected: server's address: " <<  hp->h_name << endl;

	bp = rbuf;
	bytes_to_read = BUFLEN;

	for(;;)
	{
		n = read(sd, bp, bytes_to_read);
		
		if(n <= 0)
		{
			if(errno != EAGAIN)
				break;
			else
				continue;
		}

	
		bp += n;
		bytes_to_read -= n;

		if(!bytes_to_read)
			break;
	}

	int length = strlen(rbuf);

	int size;
	memcpy(&size, rbuf, sizeof(int));

	cout << "size: " << size << endl;

	int elements[interval];

	for(int i = 0;i < size;i++)
	{
		memcpy(&elements[i], &rbuf[4*(i+1)], sizeof(int));
		cout << elements[i] << " ";
	}
	
	cout << endl;

	/*** sort the elements ***/

	for(int i = 0; i < size - i;i++)
		for(int j = 0;j < size - i - 1;j++)
			if(elements[j] > elements[j+1])
			{
				int temp = elements[j];
				elements[j] = elements[j+1];
				elements[j+1] = temp;
			}

	for(int i = 0; i < size;i++)
	{
		cout << elements[i] << endl;
		memcpy(&rbuf[sizeof(int)*i], &elements[i], sizeof(int));
	}
		
	/*** write back sorted array ***/

	write(sd, rbuf, BUFLEN);
	
	close(sd);
}

