/* TCP client */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <iostream.h>
#include <netdb.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#define SERVER_TCP_PORT 3000
#define BUFLEN		256
#define DELIMITER	'd'

const int interval = 3;

int main(int argc, char** argv)
{
	int n;
	int bytes_to_read;
	int sd;
	int port = SERVER_TCP_PORT;
	int i;

	struct hostent *hp;
	struct sockaddr_in server;
	char *host = "127.0.0.1";
	char *bp, rbuf[BUFLEN], sbuf[BUFLEN];

	/*Create a stream socket*/

	if ((sd = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	{
		cerr << "client: can't create a socket\n";
		exit(1);
	}

	bzero((char*)&server, sizeof(struct sockaddr_in));
	server.sin_family = AF_INET;
	server.sin_port = htons(port);

	if((hp = gethostbyname(host)) == NULL)
	{
		cerr << "client: can't get server's address\n";
		exit(1);
	}
	
	bcopy(hp->h_addr, (char*) &server.sin_addr, hp->h_length);

	/* connecting to the server */

	if(connect(sd, (struct sockaddr*) &server, sizeof(server)) == -1)
	{
		cerr << "client: can't connect";
		exit(1);
	}

	cout << "Connected: server's address: " <<  hp->h_name << endl;

	bp = rbuf;
	bytes_to_read = BUFLEN;

	for(;;)
	{
		n = read(sd, bp, bytes_to_read);
		
		if(n <= 0)
		{
			if(errno != EAGAIN)
				break;
			else
				continue;
		}

	
		bp += n;
		bytes_to_read -= n;

		if(!bytes_to_read)
			break;
	}

	int row[10];
	int col[10];

	int row_length = 0, col_length = 0;
	
	/*** read the size of the row and col ***/

	int index = 0;

	for(; index < BUFLEN && rbuf[index] != DELIMITER;index++, row_length++)
	{
	}
	
	index++;

	for(;index < BUFLEN && rbuf[index] != DELIMITER;index++, col_length++)
	{
	}
	
	/*** read the row ***/

	memcpy(row, rbuf, row_length);

	/*** read the col ***/

	memcpy(col, &rbuf[row_length+1], col_length);

	row_length /= sizeof(int);
	col_length /= sizeof(int);

	cout << "col length: " << col_length << endl;
	cout << "row length: " << row_length << endl;
	
	cout << "Rows: " << endl;

	for(int i = 0;i < row_length;i++)
		cout << row[i] << " ";
	
	cout << endl;

	for(int i = 0;i < col_length;i++)
		cout << col[i] << " ";
	cout << endl;
		
	int product = 0;
	/*** multiply ***/

	for(int i = 0; i < row_length;i++)
		product += row[i] * col[i];
	
	cout << "product: " << product << endl;

	memcpy(&rbuf, &product, sizeof(int));
	
	/*** write back product ***/

	write(sd, rbuf, BUFLEN);
	
	close(sd);
}

